#ifndef UTILITIES_H
#define UTILITIES_H


#include<cstdlib>
#include<cstdio>
#include<iostream>
#include<cassert>
#include <new>
#include <vector>
#include <set>
#include<fstream>

using namespace std;



#ifndef HAVE_BASENAME
#define basename(s) (strrchr((s), '/') == NULL ? (s) : strrchr((s), '/') + 1)
#endif

#define FALSE 0
#define TRUE 1


#define fvalue int
#define MAX_FVALUE  INT_MAX

typedef int Color;
typedef unsigned int Vertex;
typedef vector<Color> ColorMap;
typedef set<Vertex> VertexSet;

#ifndef HAVE_BASENAME
#define basename(s) (strrchr((s), '/') == NULL ? (s) : strrchr((s), '/') + 1)
#endif


#ifndef max
#define max(a, b) ((a) >= (b) ? (a) : (b))
#endif

#ifndef min
#define min(a, b) ((a) <= (b) ? (a) : (b))
#endif


extern long int *array;

struct compare
  {
    bool operator()(const Vertex &s1, const Vertex &s2) const
    {
      return array[s1] > array[s2];
    }
  };


#endif

